*** Program.: Dlogdemo.prg
*** Purpose.: Used to test dialog.prg...
*** System..: 
*** Author..: Kevin Neubert
*** Created.: Wednesday, 05/23/90 at 05:46 pm
*** Revised.: v.2.1 Last Revised: Thursday, 07/05/90 at 10:24 am
*** Syntax..: do dlogdemo
*** Notes...: 
***
*** (c) 1990 by Kevin Neubert
***
***      * = Fields replaced in database.
*** Dbfs....:  none
***   used..:

do sysinit with .t.
do titlescrn

*** define local variables outside of loop so that user's
*** variables will be retained while within loop...
gd_date_s  = ctod(substr(dtoc(date()),1,3) + "01" + substr(dtoc(date()),6,3))
gd_date_e  = date()
gl_radio1  = .t.
gl_radio2  = .f.
gl_check1  = .t.
gl_check2  = .f.
gc_popbutn = "Pop button #1"
gc_dloghdl = ""

DO WHILE .t.
  *** valid statement used to validate  OK  within dialog...
  *** must be defined before defining dialog data...
  gc_okvalid = "iif(date() >= _dgarray(3,2) .and. date() <= _dgarray(4,2) .and. _dgarray(6,5), .t., .f.)"

  *** define dialog data...
  *** "_dgarray" must be initialized prior to calling dlog_def...
  _dgarray = .t.
  do dlog_def

  *** activate dialog...
  *** dialog handle "gc_dloghdl" is passed so that if dialog was not cleared
  *** it will not blink off & on...
  gc_dloghdl = dialog(gc_dloghdl, 10, "dlog_chk", gc_okvalid)

  IF _dgarray(10,5)
    *** < Cancel > was selected...
    *** clear dialog...
    = dialog(gc_dloghdl, .f.)
    EXIT
  ELSE
    *** gather local variables from dialog data modified by user...
    gl_radio1  = _dgarray(1,5)
    gl_radio2  = _dgarray(2,5)
    gd_date_s  = _dgarray(3,2)
    gd_date_e  = _dgarray(4,2)
    gl_check1  = _dgarray(6,5)
    gl_check2  = _dgarray(7,5)
    gc_popbutn = _dgarray(8,5)
  ENDIF

  = wrtqury(17, 47, "OK was selected.", "\P")
ENDDO

do sysinit with .f.

RETURN

*** Eop: dlogdemo

***********************************************************************************************************************************************
*** Procedur: Beep                               && dBRIEF Tag...
*** Purpose.: Beep with miscellaneous tones.
*** Created.: Thursday, 11/2/1989 at 14:00
*** Revised.: v.2.1 Last Revised: Thursday, 5/18/1989 at 8:03
*** Syntax..: do beep with <expC>
*** Notes...: pc_type = type of beep to produce.

procedure beep
parameters pc_type
private lc_talk, lc_console, ln_loop

*** change talk setting...
lc_talk = set("talk")
set talk off

lc_console = set("console")
set console on

DO CASE
  CASE pc_type = "E"
    *** beep error...
    set bell to 60,10
    ?? chr(7)
  CASE pc_type = "A"
    *** beep alert...
    set bell to 2000,3
    ?? chr(7)

    FOR ln_loop = 1 to 100
    ENDFOR

    ?? chr(7)

    FOR ln_loop = 1 to 100
    ENDFOR

    ?? chr(7)
  CASE pc_type = "M"
    *** beep message...
    set bell to 500,3
    ?? chr(7)
  OTHERWISE
    *** unknown parameter...
    set bell to 1500,2
    ?? chr(7)

    FOR ln_loop = 1 to 100
    ENDFOR

    ?? chr(7)

    FOR ln_loop = 1 to 100
    ENDFOR

    ?? chr(7)
ENDCASE

set bell to 60,10
set console &lc_console
set talk &lc_talk

RETURN

*** Eop: Beep

***********************************************************************************************************************************************
*** Function: dlog_chk                           && dBRIEF Tag...
*** Purpose.: called from Dialog.prg to process selections in dialog box...
*** Created.: Monday, 05/07/90 at 02:19 pm
*** Revised.: v.2.1 Last Revised: 
*** Syntax..: dlog_chk(expN)
*** Notes...: 

function dlog_chk
parameters pn_item

DO CASE
  CASE pn_item = 0
    @  0,1  say "Dialog example:"
    @  (_dgarray(1,3) - 1),(_dgarray(1,4) - 1) to (_dgarray(2,3) + 1),25
    @  (_dgarray(3,3) - 1),(_dgarray(3,4) - 2) say "Get fields:"
    @  _dgarray(3,3),(_dgarray(3,4) + 9) say "to"
    @  (_dgarray(5,3) - 1),(_dgarray(5,4) - 1) to (_dgarray(7,3) + 1),25
  CASE pn_item = 5
    = wrtqury("Text button selected.", "\P")
  CASE pn_item = 7
    *** only execute procedure if turning on...

    IF _dgarray(7,5)
      = wrtqury("Procedures may be executed from any option.", "\P")
    ENDIF

  CASE pn_item = 8
    private lc_pop, ln_choice
    dimension lc_pop(5)
    lc_pop(1) = "Pop button #1"
    lc_pop(2) = "Pop button #2"
    lc_pop(3) = "Pop button #3"
    lc_pop(4) = "Pop button #4"
    lc_pop(5) = "Pop button #5"
    @ (_dgarray(8,3)-2),(_dgarray(8,4)+2) menu lc_pop, 5 shadow
    set confirm on
    read menu to ln_choice

    IF ln_choice > 0
      _dgarray(8,2) = lc_pop(ln_choice)
    ENDIF

ENDCASE

RETURN

*** Eop: dlog_chk

***********************************************************************************************************************************************
*** Function: dlog_def()                          && dBRIEF Tag...
*** Purpose.: get data to print log entries by...
*** Created.: Monday, 05/07/90 at 02:20 pm
*** Revised.: v.2.1 Last Revised: Wednesday, 05/23/90 at 11:58 am
*** Syntax..: dlog_def()
*** Notes...: 

function dlog_def

***    ͻ
*** 0   Dialog Test:                                   
*** 1                                                  
*** 2   Ŀ                      
*** 3   1 ) Radio button #1                          
*** 4   2 ) Radio button #2      ķ   
*** 5     8 Pop button #1    
*** 6    Get fields:               ͼ   
*** 7      3 to 4                        
*** 8   Ŀ                      
*** 9   5 Text button... >                           
*** 10                               9   OK         
*** 11  6 ] Check box #1                             
*** 12  7 ] Check box #2             10Cancel >      
*** 13                        
***    ͼ
***               11111111112222222222333333333344444
***     012345678901234567890123456789012345678901234

*** _dgarray(x,1) = type.
***                "R#" = radio button. (# = radio button group number)
***                "T"  = text button.
***                "P"  = pop button.
***                "C"  = check box.
***                "G"  = get.
***                "O"  = OK text button.
***                "X"  = cancel text button.
*** _dgarray(x,2) = text for item.
*** _dgarray(x,3) = upper left row position.
*** _dgarray(x,4) = upper left column position.
*** _dgarray(x,5) = various.
***                if _dgarray(x,1) = "R" => .t. - on \ .f. - off.
***                if _dgarray(x,1) = "T" => unused.
***                if _dgarray(x,1) = "P" => actual pop button text. (assigned within Dialog)
***                if _dgarray(x,1) = "C" => .t. - on \ .f. - off.
***                if _dgarray(x,1) = "G" => length of get field.
***                if _dgarray(x,1) = "O" => .t. - ok \ .f. - not ok.
***                if _dgarray(x,1) = "X" => .t. - cancel \ .f. - don't cancel.
*** _dgarray(x,6) = .t. - selectable \ .f. - not selectable.
*** _dgarray(x,7) = procedure to execute when selected.

dimension _dgarray(10,7)

_dgarray(1,1) = "R1"
_dgarray(1,2) = "Radio button #1"
_dgarray(1,3) = 3
_dgarray(1,4) = 2
_dgarray(1,5) = gl_radio1
_dgarray(1,6) = .t.
_dgarray(1,7) = ""

_dgarray(2,1) = "R1"
_dgarray(2,2) = "Radio button #2"
_dgarray(2,3) = 4
_dgarray(2,4) = 2
_dgarray(2,5) = gl_radio2
_dgarray(2,6) = .t.
_dgarray(2,7) = ""

_dgarray(3,1) = "G"
_dgarray(3,2) = gd_date_s
_dgarray(3,3) = 7
_dgarray(3,4) = 4
_dgarray(3,5) = 8
_dgarray(3,6) = .t.
_dgarray(3,7) = ""

_dgarray(4,1) = "G"
_dgarray(4,2) = gd_date_e
_dgarray(4,3) = 7
_dgarray(4,4) = 16
_dgarray(4,5) = 8
_dgarray(4,6) = .t.
_dgarray(4,7) = ""

_dgarray(5,1) = "T"
_dgarray(5,2) = "Text button..."
_dgarray(5,3) = 9
_dgarray(5,4) = 2
_dgarray(5,5) = .f.
_dgarray(5,6) = .t.
_dgarray(5,7) = "dlog_chk"

_dgarray(6,1) = "C"
_dgarray(6,2) = "Check box #1"
_dgarray(6,3) = 11
_dgarray(6,4) = 2
_dgarray(6,5) = gl_check1
_dgarray(6,6) = .t.
_dgarray(6,7) = ""

_dgarray(7,1) = "C"
_dgarray(7,2) = "Check box #2"
_dgarray(7,3) = 12
_dgarray(7,4) = 2
_dgarray(7,5) = gl_check2
_dgarray(7,6) = .t.
_dgarray(7,7) = "dlog_chk"

_dgarray(8,1) = "P"
_dgarray(8,2) = gc_popbutn
_dgarray(8,3) = 5
_dgarray(8,4) = 28
_dgarray(8,5) = .f.
_dgarray(8,6) = .t.
_dgarray(8,7) = "dlog_chk"

_dgarray(9,1) = "O"
_dgarray(9,2) = ""
_dgarray(9,3) = 10
_dgarray(9,4) = 32
_dgarray(9,5) = .f.
_dgarray(9,6) = &gc_okvalid
_dgarray(9,7) = ""

_dgarray(10,1) = "X"
_dgarray(10,2) = ""
_dgarray(10,3) = 12
_dgarray(10,4) = 32
_dgarray(10,5) = .f.
_dgarray(10,6) = .t.
_dgarray(10,7) = ""

RETURN

*** Eop: dlog_def

***********************************************************************************************************************************************
*** Procedur: Sysinit                            && dBRIEF Tag...
*** Purpose.: Initializes system and sets up variables.
*** Created.: Saturday, 7/9/1988 at 8:56
*** Revised.: v.2.1 Last Revised: Thursday, 5/18/1989 at 12:08
*** Syntax..: do sysinit with <initL>
*** Notes...: pl_init = .t. - initialize system.
***         :           .f. - reset system for dot prompt use.

procedure sysinit
parameters pl_init

IF pl_init
  clear program
  clear typeahead
  clear window all
  = insmode(.f.)
  set alternate off
  set autosave on
  set bell off
  set blink off
  set blocksize to 33
  set border to
  set brstatus off
  set carry off
  set century off
  set clear off
  set clock to
  set clock on
  set compatible off
  set confirm on
  set console off
  set currency to "$"
  set currency left
  set cursor off
  set date to american
  set debug off
  set decimals to 2
  set deleted on
  set delimiters off
  set development off
  set device to screen
  set display to CGA
  set dohistory off
  set echo off
  set escape off
  set exact off
  set exclusive off
  set fields off
  set fixed off
  set fullpath on
  set function 1 to ""
  set function 2 to ""
  set function 3 to ""
  set function 4 to ""
  set function 5 to ""
  set function 6 to ""
  set function 7 to ""
  set function 8 to ""
  set function 9 to ""
  set function 10 to ""
  set heading off
  set help off
  set hours to 12
  set intensity on
  set lock off
  set logerrors off
  set margin to 0
  set mark to "/"
  set memowidth to 50
  set message to 24 center
  set mouse on
  set mouse to 5
  set multilocks on
  set near off
  set notify on
  set odometer to 100
  set path to
  set point to "."
  set printer off
  set refresh to 0
  set reprocess to 0
  set resource on
  set safety off
  set scoreboard off
  set separator to ","
  set shadows on
  set space off
  set status off
  set step off
  set sticky on
  set sysmenus on
  set talk off
  set typeahead to 20
  set udfparms to value
  set unique off
  set view off

  IF getenv("DEBUG") = "Y"
    set development on
    on escape do sysinit with .f.
    set escape on
    set logerrors on
  ELSE
    set escape off
    on escape
  ENDIF

  close databases
  on key label rightmouse keyboard chr(13)
ELSE
  on key label f1
  on key label f2
  on key label f3
  on key label f4
  on key label f5
  on key label f6
  on key label f7
  on key label f8
  on key label f9
  on key label f10
  set bell on
  set confirm off
  set console on
  set cursor on
  set deleted off
  set device to screen
  set escape on
  set exclusive on
  set function 2  to ""
  set function 3  to ""
  set function 4  to ""
  set function 5  to "cancel;set proc to;clear prog;clear all;clear;"
  set function 6  to "set proc to sysproc;"
  set function 7  to "set cursor on;quit;"
  set function 8  to ""
  set function 9  to "do main;"
  set function 10 to "set proc to sysproc;do sysinit with .t.;clear;"
  set heading on
  set help on
  set printer off
  set safety on
  set talk on

  IF getenv("DEBUG") = "Y"
    on escape
    on error
    set exclusive off
    clear
    suspend
  ENDIF

  clear
  close all
  clear all
  release all
  release menus
  release popups
  release windows
  on key label rightmouse
ENDIF

RETURN

*** Eop: Sysinit

***********************************************************************************************************************************************
*** Procedur: Titlescrn()                        && dBRIEF Tag...
*** Purpose.: Displays OASIS on screen...
*** Created.: Friday, 3/2/1990 at 7:21
*** Revised.: v.2.1 Last Revised: Friday, 3/2/1990 at 7:21
*** Syntax..: do titlescrn
*** Notes...: 

procedure titlescrn
private all like l*

*** save system settings...
lc_device = set("device")
lc_print  = set("print")
lc_wdw    = IIF(empty(woutput()), "screen", "window " + woutput() + " same")

*** change system settings...
set device to screen
set print off

*** clear screen...
activate screen
clear

FOR ln_loop = 2 to 24
  @ ln_loop,0 say "" color W/B
ENDFOR

@  0,0  say space(80) color scheme 3
@  1,0  say space(80) color scheme 5
@  1,31 say " ** DIALOG EXAMPLE ** " color scheme 5
@  1,1  say "v 2.1 (c)" color scheme 5

@ 23,57 say "by KEVIN NEUBERT" color GR+/B

*** reset system settings...
set print &lc_print
set device to &lc_device
activate &lc_wdw

RETURN

*** Eop: Titlescrn

***********************************************************************************************************************************************
*** Procedur: Wrtqury()                          && dBRIEF Tag...
*** Purpose.: Display messages & get input.
*** Created.: Wednesday, 3/28/1990 at 11:41
*** Revised.: v.2.1 Last Revised: Friday, 4/27/1990 at 15:13
*** Syntax..: wrtqury(<parm1>, <parm2>, <parm3>, <parm4>, <parm5>, <parm6>, <parm7>, <parm8>, <parm9>, <parm10>)
*** Notes...: row, col, msg1, msg2, beep
***         : :P= - picture clause.
***         : :V= - valid clause.
***         : :F= - function clause.
***         : :B= - range (bounds).
***         : :D= - default value.
***         :
***         : one message & default must be received.
***         : numerics received are used for top row then left col.
***         : logicals received are used for beep.

procedure wrtqury
parameters p__parm1, p__parm2, p__parm3, p__parm4, p__parm5, p__parm6, p__parm7, p__parm8, p__parm9, p__parm10
private all like l*

*** set talk off...
lc_talk = set("talk")
set talk off

*** save system settings...
lc_device = set("device")
lc_print  = set("print")
lc_cursor = set("cursor")
lc_confirm = set("confirm")
lc_wdw    = IIF(empty(woutput()), "screen", "window " + woutput() + " same")

*** change system settings...
set device to screen
set print off
set cursor off
set confirm on

*** initialize message parms...
ln_parms = parameters()
lc_msg1  = ""
lc_msg2  = ""
lc_pict  = ""
lc_valid = ""
lc_func  = ""
lc_range = ""
ll_beep  = .f.
lc_query = ""
ln_row   = .f.
ln_col   = .f.

IF ln_parms > 0

  FOR ln_loop = 1 to ln_parms

    DO CASE
      CASE type("p__parm" + ltrim(str(ln_loop))) = "N"
        l__parm = "p__parm" + ltrim(str(ln_loop))

        DO CASE
          CASE type("ln_row") = "L"
            ln_row = &l__parm
          CASE type("ln_col") = "L"
            ln_col = &l__parm
        ENDCASE

      CASE type("p__parm" + ltrim(str(ln_loop))) = "C"
        l__parm = "p__parm" + ltrim(str(ln_loop))

        DO CASE
          CASE upper(substr(&l__parm,1,3)) == ":P=" .and. len(&l__parm) > 3
            lc_pict = alltrim(right(&l__parm, (len(&l__parm) - 3)))
          CASE upper(substr(&l__parm,1,3)) == ":V=" .and. len(&l__parm) > 3
            lc_valid = strtran(alltrim(right(&l__parm, (len(&l__parm) - 3))), "~", "lc_query", 1)
          CASE upper(substr(&l__parm,1,3)) == ":F=" .and. len(&l__parm) > 3
            lc_func = alltrim(right(&l__parm, (len(&l__parm) - 3)))
          CASE upper(substr(&l__parm,1,3)) == ":B=" .and. len(&l__parm) > 3 .and. at(",", &l__parm) > 0
            lc_range = alltrim(right(&l__parm, (len(&l__parm) - 3)))
          CASE upper(substr(&l__parm,1,3)) == ":D=" .and. len(&l__parm) > 3
            lc_query = right(&l__parm, (len(&l__parm) - 3))
            lc_query = IIF(type(lc_query) = "N" .and. occurs("/", lc_query) = 2, ctod(lc_query), &lc_query)
          OTHERWISE

            DO CASE
              CASE empty(lc_msg1)
                lc_msg1 = alltrim(&l__parm)
              CASE empty(lc_msg2)
                lc_msg2 = alltrim(&l__parm)
            ENDCASE

        ENDCASE

      CASE type("p__parm" + ltrim(str(ln_loop))) = "L"
        l__parm = "p__parm" + ltrim(str(ln_loop))
        ll_beep = &l__parm
    ENDCASE

  ENDFOR

ENDIF

IF ll_beep
  do beep with "M"
ENDIF

IF .not. empty(lc_msg1)

  IF upper(lc_msg1) == "\P"
    lc_msg1 = "Press any key to continue."
  ENDIF

  IF upper(lc_msg2) == "\P"
    lc_msg2 = "Press any key to continue."
  ENDIF

  *** activate window...
  ln_width = max((len(lc_msg1) + 4), (len(lc_msg2) + 4), (len(lc_pict) + 4), 30)
  ln_hgt   = IIF(lc_msg1 == "Press any key to continue.", IIF(empty(lc_msg2), 5, 6), IIF(empty(lc_msg2), 7, 8))
  ln_hgt   = IIF(lc_msg2 == "Press any key to continue.", 6, ln_hgt)
  ln_row   = IIF(type("ln_row") = "L", 9, ln_row)
  ln_col   = IIF(type("ln_col") = "L", ((80 - ln_width) / 2), ln_col)
  define window wdw_qury from ln_row,ln_col to (ln_row + ln_hgt - 1),(ln_col + ln_width - 1);
    noclose float nogrow shadow nozoom color scheme 5
  activate window wdw_qury top

  @  1,1 say lc_msg1

  IF .not. empty(lc_msg2)
    @ 2,1 say lc_msg2
  ENDIF

  IF lc_msg1 == "Press any key to continue." .or. lc_msg2 == "Press any key to continue."
    clear typeahead
    lc_query = inkey(300,"HM")
  ELSE
    lc_chk = ""

    IF .not. empty(lc_pict)
      lc_chk   = lc_chk + " picture '" + lc_pict + "'"
    ENDIF

    IF .not. empty(lc_valid)
      lc_chk = lc_chk + " valid " + lc_valid
    ENDIF

    IF .not. empty(lc_func)
      lc_chk = lc_chk + " function '" + lc_func + "'"
    ENDIF

    IF .not. empty(lc_range)
      lc_chk = lc_chk + " range " + lc_range
    ENDIF

    @  IIF(.not. empty(lc_msg2), 4, 3),IIF(empty(lc_pict), 1, ((wcols() - len(lc_pict)) / 2)) get lc_query &lc_chk
    on key label leftmouse do wrtqurymv with mrow(""), mcol("wdw_qury")
    set cursor on

    DO WHILE .t.
      activate window wdw_qury top
      read save

      IF lastkey() = 13 .and. wontop("wdw_qury")
        clear gets
        EXIT
      ENDIF

    ENDDO

    set cursor off
    on key label leftmouse
  ENDIF

  release window wdw_qury
ENDIF

*** reset system settings...
set print &lc_print
set device to &lc_device
set cursor &lc_cursor
set confirm &lc_confirm
set talk &lc_talk
activate &lc_wdw

RETURN lc_query

procedure wrtqurymv
parameters pn_mrow, pn_mcol

IF pn_mrow = wlrow("wdw_qury") .and. pn_mcol >= 0 .and. pn_mcol <= wcols()
  ln_offset = pn_mcol + 1

  DO WHILE mdown()
    move window wdw_qury to max(mrow(""), 1),(mcol("") - ln_offset)
  ENDDO

ELSE
  do beep with "M"
ENDIF

RETURN

*** Eop: Wrtqury()

***********************************************************************************************************************************************
*** Eof: Dlogdemo.prg
